import { _decorator, Camera, clamp, Collider2D, Color, Component, Contact2DType, debug, director, Director, find, Game, instantiate, IPhysics2DContact, Label, Node, PhysicsSystem2D, Prefab, RichText, Size, sp, Sprite, SpriteFrame, tween, UITransform, Vec2, Vec3, view } from 'cc';
import { DEV, EDITOR, HTML5 } from 'cc/env';
import { Weapon } from './Weapon';
import { WeaponManager } from './WeaponManager';


let { ccclass, property } = _decorator;

@ccclass('pdGameLayer')
export class pdGameLayer extends Component {

    @property({
        type: Node, displayName: DEV && "摄像机"
    })
    camera: Node = null!;
    @property({
        type: Node, displayName: DEV && "控制游戏状态"
    })
    gameState: Node = null!;

    @property({
        type: Node, displayName: DEV && "主角"
    })
    role: Node = null!;

    @property({
        type: Node, displayName: DEV && "主角控制器"
    })
    rocker: Node = null!;

    @property({
        type: Node, displayName: DEV && "主角控制器内圈"
    })
    rocker_inside: Node = null!;


    private _minX: number = 0;
    private _minY: number = 0;
    private _maxX: number = 0;
    private _maxY: number = 0;
    private _halfViewWidth: number;
    private _halfViewHeight: number;
    private _mapSize: Vec2 = new Vec2(3750, 3750);
    private _designResolution = new Size(750, 1334);


    private _mapMin: Vec2 = new Vec2(-1875, -1875);

    private _mapMax: Vec2 = new Vec2(1875, 1875);
    protected onLoad(): void {
       
        console.log("pdGameLayer onLoad.");
        this._gameInit();
    }
    protected async _gameInit() {
        // // 根据视口大小计算边界
        // let visibleSize = view.getVisibleSize();
        // let halfWidth = visibleSize.width / 2;
        // let halfHeight = visibleSize.height / 2;

        // this._minX = halfWidth;
        // this._minY = halfHeight;
        // this._maxX = this._mapSize.x - halfWidth;
        // this._maxY = this._mapSize.y - halfHeight;

        // 获取正交相机高度（竖屏适配高度）

        // 初始化状态
        //this._initStatus();
        // 移动镜头
        //this.camera.setPosition(this.enemyHouse.position.x - view.getVisibleSize().width / 2 + this.enemyHouse.getComponent(UITransform)!.width / 2, this.camera.position.y);
        // 移除云雾
    

        // 移动场景
        //this._moveBattleScene();
        //this.schedule(this._checkSort, 0.5);
        // 播放进入音效
        //GameAudio.instance.play(MiniSoundsName.ENTER_GAME);
    }

    openSetting() {
        console.log("openSetting");
    }
    setGameState() {
        console.log("setGameState");
    }
    // lateUpdate(deltaTime: number) {
    //     let targetPos = this.role.getWorldPosition();
    //     // // 限制摄像机位置
    //     // let clampedX = clamp(targetPos.x, this._minX, this._maxX);
    //     // let clampedY = clamp(targetPos.y, this._minY, this._maxY);

    //     // this.camera.setPosition(clampedX, clampedY, 0); // Z值需大于远裁剪平面

    //     const camera = this.camera.getComponent(Camera);
    //     const screenWidth = view.getVisibleSize().width;
    //     const screenHeight = view.getVisibleSize().height;
    //     const aspect = screenWidth / screenHeight;
    //     const halfWidth = camera.orthoHeight * aspect / 2;

    //     // 摄像机限制逻辑（示例）
    //     const clampedX = clamp(targetPos.x, -1875 + halfWidth, 1875 - halfWidth);
    //     //this.node.position = new Vec3(clampedX, targetPos.y, this.node.position.z)
    //     this.camera.setWorldPosition(clampedX, targetPos.y, 0);
    // }
    onBeginContact(selfCollider: Collider2D, otherCollider: Collider2D, contact: IPhysics2DContact | null) {
        // 只在两个碰撞体开始接触时被调用一次
        console.log('onBeginContact');
        let otherWeapon = otherCollider.node.getComponent(Weapon);
        let selfWeapon = selfCollider.node.getComponent(Weapon);
        if (otherWeapon && selfWeapon && otherWeapon._faction !== selfWeapon._faction) {
            // 通知双方管理器
            this.node.parent.getComponent(WeaponManager)?.handleKnockback(this.node);
            otherCollider.node.parent.getComponent(WeaponManager)?.handleKnockback(otherCollider.node);
        }

        // // 1. 获取实际碰撞点
        // let collisionPoint: Vec3;

        // if (contact) {
        //     const manifold = contact.getWorldManifold();
        //     if (manifold.points.length > 0) {
        //         // 使用第一个接触点的世界坐标
        //         const worldPoint = manifold.points[0];
        //         collisionPoint = new Vec3(worldPoint.x, worldPoint.y);

        //         // 调试绘制碰撞点（红色圆点）
        //         //debug.drawCircle(collisionPoint, 5, Color.RED);
        //     } else {
        //         // 无接触点时使用包围盒中心
        //         this.node.parent.getComponent(WeaponManager)?.(selfCollider, otherCollider);
        //     }
        // } else {
        //     collisionPoint = this.calculateFallbackPoint(selfCollider, otherCollider);
        // }
    }
    protected onEndContact(selfCollider: Collider2D, otherCollider: Collider2D, contact: IPhysics2DContact | null) {

        console.log('onEndContact');
    }
}